package de.mdelab.expressiondialogs;


import java.util.HashMap;
import java.util.Map;

import org.eclipse.emf.common.util.TreeIterator;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.swt.widgets.Shell;

import de.mdelab.mlcore.MLNamedElement;
import de.mdelab.mlcore.MLTypedElement;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.ActivityParameter;
import de.mdelab.mlsdm.ActivityParameterDirectionEnum;


public class EditExpressionDialog extends CommonEditExpressionDialog
{

	public EditExpressionDialog(Shell parent)
	{
		super(parent);
	}

	private Activity	activity;

	public void setActivity(Activity activity)
	{
		this.activity = activity;
		this.setRootContainer(activity);
	}

	@Override
	protected Map<String, EClassifier> getContextInformation()
	{
		Map<String, EClassifier> contextInfos = new HashMap<String, EClassifier>();
		if (this.activity != null)
		{
			/*
			 * THIS and parameters
			 */
			if (this.activity/*.getSpecification()*/ != null)
			{
				EClass thisClass = null;//this.activity.getSpecification().getEContainingClass();

				if (thisClass != null)
				{
					contextInfos.put("this", thisClass);
				}

				for (ActivityParameter parameter : this.activity.getParameters())
				{
					if (parameter.getName() != null && !"".equals(parameter) && parameter.getType() != null)
					{
						contextInfos.put(parameter.getName(), parameter.getType());
					}
				}
			}
			else
			{
				for (ActivityParameter parameter : this.activity.getParameters())
				{
					if ((parameter.getDirection() == ActivityParameterDirectionEnum.IN || parameter.getDirection() == ActivityParameterDirectionEnum.OUT)
							&& parameter.getName() != null && !"".equals(parameter) && parameter.getType() != null)
					{
						contextInfos.put(parameter.getName(), parameter.getType());
					}
				}
			}

			/*
			 * Variables created in story patterns and
			 * VariableDeclarationActions
			 */
			TreeIterator<EObject> it = this.activity.eAllContents();

			while (it.hasNext())
			{
				EObject eObject = it.next();

				if (eObject instanceof MLNamedElement && eObject instanceof MLTypedElement)
				{
					System.out.println(eObject);
					//StoryPatternObject spo = (StoryPatternObject) eObject;

					if (((ENamedElement) eObject).getName() != null && !"".equals(((ENamedElement) eObject).getName()) && ((MLTypedElement) eObject).getType() != null)
					{
						contextInfos.put(((MLNamedElement) eObject).getName(), ((MLTypedElement) eObject).getType());
					}
				}
				/*else if (eObject instanceof VariableDeclarationAction)
				{
					VariableDeclarationAction vda = (VariableDeclarationAction) eObject;

					if (vda.getName() != null && !"".equals(vda.getName()) && vda.getType() != null)
					{
						contextInfos.put(vda.getName(), vda.getType());
					}
				}*/
			}
		}

		return contextInfos;
	}

}
