package de.mdelab.expressiondialogs.actions;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.emf.commands.core.command.AbstractTransactionalCommand;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.window.Window;

import de.mdelab.expressiondialogs.MlsdmEditExpressionDialog;
import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlexpressions.MLStringExpression;
import de.mdelab.mlexpressions.MlexpressionsFactory;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.diagram.edit.parts.ExpressionLinkEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternLinkEditPart;
import de.mdelab.mlstorypatterns.ExpressionLink;
import de.mdelab.mlstorypatterns.MatchTypeEnum;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.StoryPatternLink;

public class EditStoryPatternExpressionLinkExpression extends EditExpressionAction
{

	@Override
	protected EClassifier getExpectedClassifier()
	{
		return ((StoryPatternLink) this.getExpressionOwner()).getTarget().getType();
	}

	@Override
	protected MLExpression getExpression()
	{
		return null;//((StoryPatternLink) this.getExpressionOwner()).getExpression();
	}

	@Override
	protected TransactionalEditingDomain getEditingDomain()
	{
		return ((StoryPatternLinkEditPart) getStructuredSelection().getFirstElement()).getEditingDomain();
	}

	@Override
	protected void setNewExpression(MLExpression newExpression)
	{
		StoryPatternLink spl = (StoryPatternLink) this.getExpressionOwner();

		//spl.setExpression(newExpression);
	}

	@Override
	protected EClassifier getContextClassifier()
	{
		return ((StoryPatternLink) this.getExpressionOwner()).getSource().getType();
	}

	//@Override
	protected Activity getActivity()
	{
		EObject container = this.getExpressionOwner();

		while (!(container instanceof Activity))
		{
			container = container.eContainer();
		}

		return (Activity) container;
	}

	@Override
	protected EObject getExpressionOwner()
	{
		return ((View) ((StoryPatternLinkEditPart) getStructuredSelection().getFirstElement()).getModel()).getElement();
	}
	


	@Override
	protected void prepareDialog()
	{
		super.prepareDialog();
		editExpressionDialog.setActivity(getActivity());
		editExpressionDialog.setStructuralFeature(MlstorypatternsPackage.eINSTANCE.getExpressionLink_Expression());//getStoryPatternExpressionLink_Expression());
	}
}
