package de.mdelab.expressiondialogs.actions;

import javax.swing.JOptionPane;

import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.gmf.runtime.diagram.ui.editparts.CompartmentEditPart;
import org.eclipse.gmf.runtime.notation.View;

import de.mdelab.expressiondialogs.MlsdmEditOutParameterExpressionDialog;
import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.StoryNode;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.StoryPattern;
import de.mdelab.mlstorypatterns.StoryPatternObject;

public class EditStoryPatternObjectExpressionNewAction extends EditExpressionAction
{

	@Override
	protected EClassifier getExpectedClassifier()
	{
		return EcorePackage.eINSTANCE.getEBoolean();
	}

	@Override
	protected MLExpression getExpression()
	{
		if (((View) ((CompartmentEditPart) getStructuredSelection().getFirstElement()).getModel()).getElement() instanceof MLExpression)
			return (MLExpression) ((View) ((CompartmentEditPart) getStructuredSelection().getFirstElement()).getModel()).getElement();
		return null;
	}

	@Override
	protected TransactionalEditingDomain getEditingDomain()
	{
		return ((CompartmentEditPart) getStructuredSelection().getFirstElement()).getEditingDomain();
	}

	@Override
	protected void setNewExpression(MLExpression newExpression)
	{
		MLExpression oldExpression = getExpression();
		StoryPatternObject spo = (StoryPatternObject) oldExpression.eContainer();

		spo.getConstraints().remove(oldExpression);
		spo.getConstraints().add(newExpression);
	}

	@Override
	protected EClassifier getContextClassifier()
	{
		/*StoryNode sN = (StoryNode) ((View) ((CompartmentEditPart) getStructuredSelection().getFirstElement()).getParent().getParent()
				.getModel()).getElement()
				sN.getStoryPattern().g;
		return ((StoryPatternObject) ((View) ((CompartmentEditPart) getStructuredSelection().getFirstElement()).getParent().getParent()
				.getModel()).getElement()).getType();*/
		return null;
	}

	//@Override
	protected Activity getActivity()
	{
		EObject container = ((StoryPattern) ((View) ((CompartmentEditPart) getStructuredSelection().getFirstElement()).getParent()
				.getParent().getModel()).getElement()).eContainer();

		while (!(container instanceof Activity))
		{
			if (container==null) return null;
			container = container.eContainer();
		}

		return (Activity) container;
	}

	@Override
	protected EObject getExpressionOwner()
	{
		return this.getExpression().eContainer();
	}

	@Override
	protected void prepareDialog()
	{		
		MlsdmEditOutParameterExpressionDialog dialog = new MlsdmEditOutParameterExpressionDialog(null);
		//dialog.setActivity(getActivity());
		editExpressionDialog = dialog;
		editExpressionDialog.setExpression(getExpression());
		editExpressionDialog.setExpectedClassifier(getExpectedClassifier());
		editExpressionDialog.setContextClassifier(getContextClassifier());
		editExpressionDialog.setExpressionOwner(getExpressionOwner());
		editExpressionDialog.setEditingDomain(getEditingDomain());		
		
		editExpressionDialog.setRootContainer(getActivity());
		
		editExpressionDialog.setActivity(getActivity());
		editExpressionDialog.setStructuralFeature(MlstorypatternsPackage.eINSTANCE.getStoryPatternObject_Constraints());
	}
}
