package de.mdelab.expressiondialogs.actions;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;

import de.mdelab.mlsdm.diagram.edit.parts.StoryNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryNodeStoryNodeElementsCompartmentEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternEditPart;

public class ShowAllStoryPatternObjectsAction extends CustomAbstractActionDelegate
{

	StoryNodeEditPart	storyActionNodeEditPart	= null;

	@Override
	public void selectionChanged(IAction act, ISelection selection)
	{
		if (selection instanceof IStructuredSelection)
		{
			storyActionNodeEditPart = (StoryNodeEditPart) ((IStructuredSelection) selection).getFirstElement();
		}
	}

	@Override
	protected void doRun(IProgressMonitor progressMonitor)
	{
		StoryNodeStoryNodeElementsCompartmentEditPart elementsCompartmentEditPart = null;

		for (Object object : storyActionNodeEditPart.getChildren())
		{
			if (object instanceof StoryNodeStoryNodeElementsCompartmentEditPart)
			{
				elementsCompartmentEditPart = (StoryNodeStoryNodeElementsCompartmentEditPart) object;
				break;
			}
		}

		for (Object object : ((StoryPatternEditPart)elementsCompartmentEditPart.getChildren().get(0)).getChildren())
		{
			if (object instanceof GraphicalEditPart)
			{
				GraphicalEditPart editPart = (GraphicalEditPart) object;

				/*
				 * Show the figure
				 */
				editPart.getFigure().setVisible(true);

				/*
				 * Show all connected links
				 */
				for (Object object2 : editPart.getSourceConnections())
				{
					if (object2 instanceof GraphicalEditPart)
					{
						((GraphicalEditPart) object2).getFigure().setVisible(true);
					}
				}

				for (Object object2 : editPart.getTargetConnections())
				{
					if (object2 instanceof GraphicalEditPart)
					{
						((GraphicalEditPart) object2).getFigure().setVisible(true);
					}
				}

			}
		}
	}

}
